<?php
$template->replace('{TEMPLATESDIR}', $templatesdir);

// Check for custom-specified permissions restrictions.
if (strstr($template->text, '<!-- RESTRICT TO GROUPS'))
{
 $groups = templateextract($template->text, '<!-- RESTRICT TO GROUPS ', ' -->');
 $groups = str_replace('<!-- RESTRICT TO GROUPS ', '', $groups);
 $thegroups = explode(',', $groups);
 $comeonin = false;
 $num = sizeof($thegroups);
 for ($x=0; $x<$num; $x++)
 {
  if ($thismember->usergroup == $thegroups[$x]) $comeonin = true;
 }
 if (!$comeonin) $template->text = $language->noaccess; 
} 

$header = str_replace('{TEMPLATESDIR}', $templatesdir, $header);

if ($nomemberinfo) { $footer = memberreplacements($footer, $thismember); $header = memberreplacements($header, $thismember); }

if ($headerfooter != 'no')
 $totalpage = $header . $template->text . $footer;
else
 $totalpage = $template->text;

// global variables and macros
$totalpage = str_replace('{AREA}', $area, $totalpage); // define area for page title
if (strstr($totalpage, '{TOTALMEMBERS}'))
{
 $gettotal = $db->select('id','memberstable','id>0','','');
 $totalmembers = $db->numrows($gettotal);
 $totalpage = str_replace('{TOTALMEMBERS}', $totalmembers, $totalpage);
}
if (strstr($totalpage, '{LANG_')) $totalpage = langreplacements($totalpage);

// do toplists
$num = $_GET['num'];
if (!$num) $num = $_POST['num'];
for ($loopthis = 1; $loopthis<30; $loopthis++) // they couldn't have more than 30 on a page, could they?
{
if (strstr($totalpage, '<!-- BEGIN TOPLIST '. $loopthis .' -->'))
{ 
 $blanktemplate = templateextract($totalpage, '<!-- BEGIN TOPLIST '. $loopthis .' -->', '<!-- END TOPLIST '. $loopthis .' -->');
 $totalpage = str_replace($blanktemplate, '{TOPLISTAREA}', $totalpage);
 $commands = templateextract($blanktemplate, '<CONFIG>', '</CONFIG>');
 $blanktemplate = str_replace($commands, '', $blanktemplate);
 $blanktemplate = str_replace('</CONFIG>', '', $blanktemplate);
 $row = explode(',', $commands);
 if (!$type[$loopthis]) $type[$loopthis] = $row[0];
 if (!$field[$loopthis]) $field[$loopthis] = $row[1];
 if (!$number[$loopthis]) $number[$loopthis] = $row[2];
 if (!$order[$loopthis]) $order[$loopthis] = $row[3];
 if ((sizeof($row) > 3) && (!$thecondition[$loopthis])) $thecondition[$loopthis] = $row[4];
 if ((sizeof($row) > 4) && (!$thestart[$loopthis])) $thestart[$loopthis] = $row[5];
 else $thestart[$loopthis] = 0;
 $type[$loopthis] = str_replace('<CONFIG>', '', $type[$loopthis]);
 if ($type[$loopthis] == 'entries') $selectfields[$loopthis] = $settings->linkfields;
 if ($type[$loopthis] == 'comments') $selectfields[$loopthis] = $settings->commentfields;  
 if ($type[$loopthis] == 'members') $selectfields[$loopthis] = $settings->memberfields;
 if ($order[$loopthis] == 'ascending') $realorder[$loopthis] = 'ASC';
 else if ($order[$loopthis] == 'descending') $realorder[$loopthis] = 'DESC';
 else $realorder[$loopthis] = $order[$loopthis];
 if ($type[$loopthis] == 'entries') $table[$loopthis] = 'linkstable';
 else $table[$loopthis] = $type[$loopthis] . 'table';
 $condition = '';
 if ($type[$loopthis] != 'members') $condition = 'validated=1'; 
 if ($type[$loopthis] == 'entries') $condition .= ' AND hide=0';
 if (($type[$loopthis] != 'members') && ($settings->condition != '') || ($thecondition[$loopthis] != '')) $condition .= ' AND ';
 if ($thecondition[$loopthis] != '') $condition .= $thecondition[$loopthis];
 if ($settings->condition != '') $condition .= ' AND '. $settings->condition;    
 if ($condition == '') $condition = 'id>0';
 if ($thestart[$loopthis] == '') $thestart[$loopthis] = 0;
 $query = $db->select($selectfields[$loopthis], $table[$loopthis], $condition, "ORDER BY $field[$loopthis] $realorder[$loopthis]", "LIMIT $thestart[$loopthis],$number[$loopthis]");
 $num[$loopthis] = $db->numrows($query);
 $ourtemplate = '';
 for ($count=0; $count<$num[$loopthis]; $count++)
 {
  $row = $db->row($query);
  if ($type[$loopthis] == 'entries')
  {
   $ourobject = new onelink('row', $row);
   $ourtemplate .= linkreplacements($blanktemplate, $ourobject);
  }
  if ($type[$loopthis] == 'comments')
  {
   $ourobject = new comment('row', $row);
   $ourtemplate .= commentreplacements($blanktemplate, $ourobject);  
  }
  if ($type[$loopthis] == 'members')
  {
   $ourobject = new member('row', $row);
   $ourtemplate .= memberreplacements($blanktemplate, $ourobject);  
  }
  $ourtemplate = str_replace('{NUMBER}', $count+1, $ourtemplate);
 }
 $totalpage = str_replace('{TOPLISTAREA}', $ourtemplate, $totalpage);
}
}

// allow user to display the number shown in a dynamic fashion
for ($loopthis=1;$loopthis<10;$loopthis++) $totalpage = str_replace('{TOPLISTTOTAL'. $loopthis.'}', $num[$loopthis], $totalpage);

if (!$nomemberinfo) $totalpage = memberreplacements($totalpage, $thismember); // if any member vars left over, assume they're for viewer

$totalpage = str_replace('{LANGOPTIONS}', langoptions($languagegroup), $totalpage);
$totalpage = str_replace('{TEMPOPTIONS}', tempoptions($templatesdir), $totalpage);

if (!$leaveencoded) $totalpage = decodeit($totalpage);
$phpized = OutputPhpDocument($totalpage);

$db->closedb($connection); 

if ($debug)
{
 if ($debug == 2) echo $debuginfo;
 if ($debug == 3) if ($thismember->isadmin()) echo $debuginfo;
 if ((($debug > 0) && ($debug < 5)) || (($debug == 5) && ($thismember->isadmin())))
 {
  echo "$querycount total queries<br>";
  $mtime = microtime(); 
  $mtime = explode(" ",$mtime); 
  $mtime = $mtime[1] + $mtime[0]; 
  $endtime = $mtime; 
  $totaltime = ($endtime - $starttime); 
  echo "This page was created in ".$totaltime." seconds"; 
 }
}

?>